#include "Max7219.h"


void Load_Low(void)
{
  PORTB &= ~(1 << PB2);
}

void Load_High(void)
{
  PORTB |= (1 << PB2);
}

void SPIMasterInit(void)
{
    DDRB = (1<<PB2)|(1<<PB3)|(1<<PB5);      // set PB2(SS), PB3 (MOSI) and PB5 (SCK) output, all others input
    SPCR = (1<<SPE)|(1<<MSTR);           // enable SPI, Master, set clock rate fck/4
    PORTB |= (1 << PB7)|(1 << PB2);
}

void transmit(unsigned char addr, char data) 
{
     Load_Low();
  SPDR = addr;                      // Start transmission
  while(!(SPSR & (1<<SPIF)));           // Wait for transmission complete

  asm volatile("nop");

  SPDR = data;                      // Start transmission
  while(!(SPSR & (1<<SPIF)));            // Wait for transmission complete
      Load_High();
}

void SetMode(unsigned mode)
{
    transmit(0x0C,mode); 
}
void SetDecodeMode(uint8_t mode)
{
    transmit(0x09,mode);    //0x00 no decode / 0xFF all decode
}
void SetScanLimit(uint8_t mode)
{
    transmit(0x0B,mode);
}

void SetIntensity(uint8_t mode)
{
    transmit(0x0A,mode);       
}

void DisplayTest(unsigned mode)
{
    transmit(0x0F,mode); 
}

uint8_t code[] = {1,5,7,3,2,6,4,0};

void SetDigit(uint8_t digit, uint8_t data)
{
    transmit(code[digit]+1,data);
}

void SetAll(uint8_t data)
{
    for(uint8_t i = 1; i!=9;i++)
        transmit(i,data);   
}
