#include <avr/io.h>
#include <avr/interrupt.h>


#ifndef F_CPU
/* Definiere F_CPU, wenn F_CPU nicht bereits vorher definiert
(z.B. durch bergabe als Parameter zum Compiler innerhalb
des Makefiles). Zustzlich Ausgabe einer Warnung, die auf die
"nachtrgliche" Definition hinweist */
#warning "F_CPU war noch nicht definiert, wird nun mit 8000000 definiert"
#define F_CPU 8000000UL /* Quarz mit 8 Mhz */
#endif 
#include <util/delay.h>
#include <stdlib.h>
#include "Max7219.h"

uint8_t chars[] = {126,48,109,121,51,91,95,112,127,123};

uint16_t timercounter = 0; 

int main(void)
{
    //Init MAX7219
    SPIMasterInit();
    SetMode(MAX_MODE_NORMAL);
    SetIntensity(0x0F);
    SetDecodeMode(0x00);
    SetScanLimit(0x07);
    SetAll(0);
    
    //8bit Timer Init
    TCCR0 = (1<<CS00);          //Kein Teiler
    TIMSK |= (1<<TOIE0);        // Overflow Interrupt erlauben
    sei();                      // Global Interrupts aktivieren
    
    //Zhlvariablen initialisieren       
    uint8_t sec = 0;
    uint8_t sec10 = 0;
    uint8_t min = 0;
    uint8_t min10 = 0;
    
    uint16_t quotient = 7998976 / 256;
    
    while(1) 
    {
        if(timercounter >= quotient)
        {
            timercounter = 0;
            sec++;
            if(sec==10)
            {
                sec = 0;
                sec10++;
                if(sec10 == 6)
                {
                 sec10 = 0;
                 min++;
                 if(min == 10)
                 {
                     min = 0;
                     min10++;
                     if(min10 == 10)
                     min10 = 0;   
                    }   
                }
            }
        }
        SetDigit(3,chars[sec]);
        SetDigit(2,chars[sec10]);
        SetDigit(1,chars[min]+128);
        SetDigit(0,chars[min10]);
    }
}

ISR (TIMER0_OVF_vect)
{
  timercounter++;
}

